﻿Public Class TopoSorter(Of T) : Inherits System.Collections.ObjectModel.Collection(Of T)

   Private _GetSuccessors As Func(Of T, IEnumerable(Of T))

   Public Sub New(ByVal GetSuccessors As Func(Of T, IEnumerable(Of T)))
      _GetSuccessors = GetSuccessors
   End Sub

   Protected Overrides Sub InsertItem(ByVal index As Integer, ByVal item As T)
      'vor dem nächsten Item einsortieren, dessen Parent (direkt oder indirekt) es ist
      For index = 0 To MyBase.Count - 1
         If IsPrecuserOf(item, Me(index)) Then Exit For
      Next
      MyBase.InsertItem(index, item)
   End Sub

   Private Function IsPrecuserOf(ByVal Nd As T, ByVal F As T) As Boolean
      If Nd.Equals(F) Then Return False 'bei sich Selbst enthaltendem P EndlosRekursion vermeiden
      Dim Successors = _GetSuccessors(Nd)
      Return Successors.Contains(F) OrElse Successors.Any(Function(Nd2) IsPrecuserOf(Nd2, F))
   End Function

End Class
