' IDE-Voreinstellungen:
' Option Strict On
' Option Explicit On
' Option Infer On

' Projekt-Voreinstellungen
' Imports System
' Imports System.Drawing
' Imports System.Windows.Forms
' Imports System.Collections.Generic
' Imports System.Linq

Imports Garment = TopoSort.Tree(Of String)

Public Class frmTopoSort

   Private Function GetChildTables(ByVal Tb As DataTable) As IEnumerable(Of DataTable)
      Return From Rl In Tb.ChildRelations.Cast(Of DataRelation)() Select Rl.ChildTable
   End Function

   Private Sub btSortTables_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btSortTables.Click
      Dim Tables = Me.BestellungDataSet1.Tables.Cast(Of DataTable)()
      Dim Sorter As New TopoSorter(Of DataTable)(AddressOf GetChildTables)
      'sukzessives Zufgen von Elementen
      For Each Tb As DataTable In Tables
         Sorter.Add(Tb)
      Next

      Dim Relations = From Rel In Me.BestellungDataSet1.Relations.Cast(Of DataRelation)() _
                      Select New DataTable() {Rel.ParentTable, Rel.ChildTable}

      Dim TableDump = Function(Tbls As IEnumerable(Of DataTable)) (From Tb In Tbls Select Tb.TableName)

      With New List(Of String)
         .Add("Folgende DataTables:")
         .AddRange(TableDump(Tables))
         .Add(NewLine & "knnten in dieser Reihenfolge abgespeichert werden:")
         .AddRange(TableDump(TopoSort(Of DataTable)(Tables, AddressOf GetChildTables)))
         .Add(NewLine & "sukzessive Berechnung:")
         .AddRange(TableDump(Sorter))
         .Add(NewLine & "relations-bezogene Berechnung:")
         .AddRange(TableDump(TopoSort2(Relations)))
         MsgBox(String.Join(NewLine, .ToArray))
      End With

   End Sub

   Private Sub btSortGarments_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btSortGarments.Click
      'Kleidungsstcke erfinden
      Dim Mantel = New Garment("Mantel"), Schuhe = New Garment("Schuhe")
      Dim Unterhose = New Garment("Unterhose"), Hose = New Garment("Hose")
      Dim Socken = New Garment("Socken"), Unterhemd = New Garment("Unterhemd")
      Dim Pullover = New Garment("Pullover")
      'Anzieh-Abhngigkeiten festlegen
      Socken.Add(Schuhe)
      Hose.Add(Schuhe)
      Unterhose.Add(Hose)
      Pullover.Add(Mantel)
      Unterhemd.Add(Pullover)
      Hose.Add(Mantel)
      Dim Garments = New Garment() {Mantel, Schuhe, Unterhose, Hose, Socken, Unterhemd, Pullover}

      Dim Sorted = TopoSort(Of Garment)(Garments, Function(G) G)

      Dim Sorter As New TopoSorter(Of Garment)(Function(G) G)
      For Each G In Garments
         Sorter.Add(G)
      Next

      Dim Relations = NewArray(NewArray("Socken", "Schuhe"), _
                               NewArray("Hose", "Schuhe"), _
                               NewArray("Unterhose", "Hose"), _
                               NewArray("Pullover", "Mantel"), _
                               NewArray("Unterhemd", "Pullover"), _
                               NewArray("Hose", "Mantel"))

      With New List(Of String)
         .Add("Folgende Kleidungsstcke:")
         .AddRange(From G In Garments Select G.Value)
         .Add(NewLine & "knnten in dieser Reihenfolge angezogen werden:")
         .AddRange(From G In Sorted Select G.Value)
         .Add(NewLine & "sukzessive Berechnung:")
         .AddRange(From G In Sorter Select G.Value)
         .Add(NewLine & "relations-bezogene Berechnung:")
         .AddRange(TopoSort2(Relations))
         MsgBox(String.Join(NewLine, .ToArray))
      End With

   End Sub

End Class